<?php


// $config = get_option('woocommerce_stpays_settings');
// echo "<pre>";
// print_r($config);

// exit;

class WC_Gateway_StPays_Configuration

{

    public $settings;
    public $url_gateway;
    public $url_notifica;
    public $enviroment;
    public $api_key;
    // public $sp_user_id;
    // public $sp_user_password;
    public $sp_language;



    public function __construct($settings)

    {

        $this->settings = $settings;

        $this->init_settings();

    }



    public function init_settings()

    {
        $this->api_key = isset($this->settings['api_key']) ? trim($this->settings['api_key']) : false;
        // $this->sp_user_id = isset($this->settings['sp_user_id']) ? trim($this->settings['sp_user_id']) : false;
        // $this->sp_user_password = isset($this->settings['sp_user_password']) ? trim($this->settings['sp_user_password']) : false;

        $this->sp_language = isset($this->settings['sp_language']) ? trim($this->settings['sp_language']) : false;

    }



    public function get_form_fields()

    {

        $form_fields = array(

          'module_description' => array(

              'title' => '',

              'type' => 'title',

              'description' => __('Da questa pagina è possibile inserire le configurazioni generali del modulo. Ti ricordiamo di abilitare i singoli prodotti che intendi offrire con pagamento rateale direttamente dalla scheda prodotto.', 'stpays'),

              'class' => 'style_title'

          ),

            'title_section_1' => array(

                'title' => __('Configurazione del modulo di pagamento', 'stpays'),

                'type' => 'title',

            ),

            'enabled' => array(

                'title' => __('Abilita / Disabilita', 'stpays'),

                'type' => 'checkbox',

                'label' => __('Abilita il modulo di pagamento StPays.', 'stpays'),

                'default' => 'no'

            ),

            
            'sp_max_installments' => array(

                'title' => __('Rate massime', 'stpays'),

                'type' => 'select',

                'options' => $this->get_options_config_installments(),

                'desc_tip' => __('Seleziona il numero massimo di rate', 'stpays')

            ),

            'sp_max_periodicity' => array(

                'title' => __('Periodicità', 'stpays'),

                'type' => 'select',

                'options' => $this->get_options_config_periodicity(),

                'desc_tip' => __('Seleziona la periodicità', 'stpays')

            ),

            'sp_min_cart' => array(

                'title' => __('Importo minimo carrello - €', 'stpays'),

                'type' => 'text',

                'desc_tip' => __('Importo minimo del carrello', 'stpays')

            ),

            'sp_max_cart' => array(

                'title' => __('Importo max carrello - €', 'stpays'),

                'type' => 'text',

                'desc_tip' => __('Importo massimo del carrello', 'stpays')

            ),

            

            /*'sp_crm_url' => array(

                'title' => __('StPays CRM URL', 'stpays'),

                'type' => 'text',

                'desc_tip' => __('StPays CRM URL', 'stpays')
               

            ),*/
            'api_key' => array(
                'title' => __('StPays apikey', 'stpays'),
                'type' => 'text',
                'desc_tip' => __('Nome apikey StPays', 'stpays')
            ),
            // 'sp_user_id' => array(

            //     'title' => __('StPays Username', 'stpays'),

            //     'type' => 'text',

            //     'desc_tip' => __('Nome utente commerciante StPays', 'stpays')

            // ),

            // 'sp_user_password' => array(

            //     'title' => __('StPays Password', 'stpays'),

            //     'type' => 'password',

            //     'desc_tip' => __('Password utente commerciante StPays', 'stpays')

            // ),

             /*'sp_public_key' => array(

                'title' => __('Stripe Public Key', 'stpays'),

                'type' => 'text',

                'desc_tip' => __('Public Key del tuo Account Stripe', 'stpays')

            ),

            'sp_secret_Key' => array(

                'title' => __('Stripe Secret Key', 'stpays'),

                'type' => 'password',

                'desc_tip' => __('Private Key del tuo Account Stripe', 'stpays')

            ),*/

           

            'sp_incomplete_status' => array(

                'title' => __('Stato dellordine', 'stpays'),

                'type' => 'select',

                'description' => __("Stato dell'ordine", 'stpays'),

                'default' => 'Normal',

                'desc_tip' => true,

                'options' => $this->get_options_order_status(),

                'class' => 'build_style font-style'

            ),

            'sp_complete_status' => array(

                'title' => __('Stato pagamento', 'stpays'),

                'type' => 'select',

                'description' => __("Stato dell'ordine alla fine delle rate", 'stpays'),

                'default' => 'Normal',

                'desc_tip' => true,

                'options' => $this->get_options_order_status(),

                'class' => 'build_style font-style'

            ),

        );

        return $form_fields;

    }



    /**

     * elenco opzioni di contabilizzazione da mostrare in configurazione

     *

     * @return array

     */

    public function get_options_config_contab()

    {

        $contab_ids = array(

            "C" => 'IMMEDIATA',

            "D" => 'DIFFERITA'

        );

        return $contab_ids;

    }



    public function get_options_order_status()

    {

        return WC_Gateway_StPays::get_order_status(wc_get_order_statuses());

    }



    public function get_options_config_periodicity()

    {

        $periodicity = array(
            '1'=>'Mensile',
            '2'=>'Bimestrale',
            '3'=>'Trimestrale',
            '4' => 'Quadrimestrale',
            '6'=>'Semestrale',
            '12'=>'Annuale',
        );

        return $periodicity;

    }
    public function get_options_config_installments()

    {

        $installments = array(
        1=>1,
        2=>2,

        3=>3,

        4=>4,

        5=>5,

        6=>6,

        7=>7,

        8=>8,

        9=>9,

        10=>10,

        11=>11,

        12=>12

      );

        return $installments;

    }



    public function get_options_config_font_style()

    {

        return array("Normal" => "Normal", "Italic" => "Italic", "Oblique" => "Oblique", "Initial" => "Initial", "Inherit" => "Inherit");

    }



    public function get_options_config_font_variant()

    {

        return array("Normal" => "Normal", "Small-caps" => "Small-caps", "Initial" => "Initial", "Inherit" => "Inherit");

    }

}